#define Versus  "Version 19/04/13"

/*   
special test LCD  SANS PLL donc fosc=quartz=10Mhz          

=========== new  HARDWARE ====================

PIC 18F46K22  DIP 40   microchip  ..programme avec PICKIT3

MCLR   1  -- R=1K----|-- C=1F ------ 0V
          |          |-----R=10K --- +5V
          |------ Jaune -------------- VPP ICSP ---  pin1 Pickit3

PORTA
 RA0   2  Analog Input <---- Joystick Potar reglage 
 RA1   3  Analog Input <---- Joystick Potar deplacement Horizontal dans le menu
 RA2   4  output DAC 5 bits  ---> direct DDS 
 RA3   5  Analog Input <---- Seuil=1,65V via pont diviseur pour seuil bas compartors joystik 
 RA4   6  ---- 750 -- Led Rouge --- +5V
 RA5   7  
 
PORTE
 RE0   8  output .. Led_Down --- 750 -- +5V   (ON Decr si <400 ) 
 RE1   9  Output .. Led_Neutre   .. 750 ohms +5V ( si 401 a 599)
 RE2   10  Output .. Led_Up   --- 750 -- +5V   (ON Incr si >600)
 
 
 VDD   11 	Alim +5V
 VSS   12 	alim 0V
 			VSS---- blanc ---  Gnd  ----  pin3 Pickit3

PORTA suite 
 RA7  13 Quartz 10Mhz  C=22pF -- Gnd  x4 PLL !
 RA6  14 Quartz ---    C=22pF -- Gnd
 
PORTC
 RC0   15	input libre
 RC1   16	input libre
 RC2   17	output ..............FSEL  7 DDS AD9835 Breakout
 RC3   18 	output SPI SCLK......SCLCK 4 DDS AD9835 Breakout
 
PORTD                                        
 RD0   19	input 
 RD1   20   input 
 RD2   21   input 
 RD3   22   input 
 
PORTC .. suite
 RC4   23 	output SPI SDA ...SDATA 3 DDS AD9835 Breakout
 RC5   24 	output .......FSYNC 8 DDS AD9835 Breakout
 RC6   25  	TX  UART1 TTL  -- fil rouge -- 1 - DS275 - 5 -> RS232 -- 3 HE10 -- Rx PC ecran
 RC7   26  	RX  UART1 TTL  --- fil blanc-- 3 - DS275 - 7 <- RS232 -- 2 HE10 ---TX PC clavier
 			ou si liaison au module BT
 RC6   25  	TX  UART1 TTL  -- fil rouge ---R750--- Rx module BT
 RC7   26  	RX  UART1 TTL  ---fil blanc ---R750--- TX module BT 
 
 
PORTD .. suite
 RD4   27   input 
 RD5   28   libre
 RD6   29   reserv SoftUART2 ---> TX HARDW UART2 1200,E,7,1  
 RD7   30   reserv SOFTUART2 <--- RX HARDW UART2 1200,E,7,1 
 
 VSS	31  Alim 0V Gnd
 VDD	32 Alim +5V

PortB
 RB0  33 	input ..recoit le BP du joystick  (R 10k de rappel au +5V)
 RB1  34	input for debugging tests
 RB2  35	LCD RS
 RB3  36	LCD Enable
 RB4  37	LCD B3
 RB5  38	LCD B4
 RB6  39	LCD B6 & 750 --- ICSP_Clck   Bleu fonc    Pin5 Pickit3
 RB7  40	LCD B7 & 750 --- ICSP_Data   Bleu clair    Pin4 Pickit3

 
 VSS  12  ---- blanc ---  Gnd  ----  pin3 Pickit3
 VSS  12  ----  GND Power
 VSS  31  ----  GND Power
 VDD  11  ----  +5V Power
 VDD  32  ----  +5V Power

Interface DS275 pour liaison HARDW UART TTL <-> RS232 19200 bauds
Liaison Soft UART en niveau TTL via optocoupleur 6N138 pour reception Teleinfo 

====================================================
 

#include <p18f46k22_.h>   /* for TRISB and PORTB declarations */

#include "stdio.h"
#include <stdlib.h>
#include <delays.h>
#include <string.h>
#include <usart.h>   // pour fonctions UART
#include <adc.h>
#include <ctype.h>
#include <portb.h>
#include <timers.h>
#include <math.h>

#include <..\_common\LCD2x16.h>

// config du PIC via MPLAB
// Configure
//      select device
//           choisir PIC18F46K22
// Configurations bits
//         si la config du PIC faite par MPLAB , enlever la coche "Configuration Bits set in code".
//         dans le cas present : coche enlev
// voir Help
//  Topics
//        Pic18
//            config bits settings

#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H
#else
//#pragma config FOSC = HSMP, PLLCFG=ON, PRICLKEN=ON ,FCMEN=OFF
#pragma config FOSC = HSMP, PLLCFG=OFF, PRICLKEN=ON ,FCMEN=OFF
#endif
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,T3CMX=PORTC0,P2BMX=PORTC0
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF     

// config vue par Pickit3
// 3300 3C19 9D00 0084 C00F E00F 400F
// checksum F6E8
#define LCD2x16

#define Byte unsigned char
#define CLS 12
#define TAB 9
#define CR 13
#define LF 10
#define Bell 7
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1

#define Led_Up       LATEbits.LATE2
#define Led_Centre   LATEbits.LATE1
#define Led_Down     LATEbits.LATE0

#define   Led_Rouge  LATAbits.LATA4
#define DureeCycle 20 // * 1 diziemes de secondes => 2,0sec
#define   Max_Pos_Menu 11


#define SIZE	64		/* taille buffer */
#define TDRE	0x80


rom const char SINE_TABLE []={  // pour 1 periode !
          0x80,0x82,0x85,0x88,0x8B,0x8E,0x91,0x94,
      0x97,0x9A,0x9D,0xA0,0xA2,0xA5,0xA8,0xAB,
      0xAD,0xB0,0xB3,0xB5,0xB8,0xBB,0xBD,0xC0,
      0xC2,0xC5,0xC7,0xC9,0xCC,0xCE,0xD0,0xD2,
      0xD4,0xD6,0xD8,0xDA,0xDC,0xDE,0xE0,0xE2,
      0xE3,0xE5,0xE6,0xE8,0xE9,0xEB,0xEC,0xED,
      0xEE,0xEF,0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,
      0xF5,0xF6,0xF6,0xF7,0xF7,0xF7,0xF7,0xF7,
      0xF8,0xF7,0xF7,0xF7,0xF7,0xF7,0xF6,0xF6,
      0xF5,0xF5,0xF4,0xF3,0xF2,0xF1,0xF0,0xEF,
      0xEE,0xED,0xEC,0xEB,0xE9,0xE8,0xE6,0xE5,
      0xE3,0xE2,0xE0,0xDE,0xDC,0xDA,0xD8,0xD6,
      0xD4,0xD2,0xD0,0xCE,0xCC,0xC9,0xC7,0xC5,
      0xC2,0xC0,0xBD,0xBB,0xB8,0xB5,0xB3,0xB0,
      0xAD,0xAB,0xA8,0xA5,0xA2,0xA0,0x9D,0x9A,
      0x97,0x94,0x91,0x8E,0x8B,0x88,0x85,0x82,
      0x80,0x7D,0x7A,0x77,0x74,0x71,0x6E,0x6B,
      0x68,0x65,0x62,0x5F,0x5D,0x5A,0x57,0x54,
      0x52,0x4F,0x4C,0x4A,0x47,0x44,0x42,0x3F,
      0x3D,0x3A,0x38,0x36,0x33,0x31,0x2F,0x2D,
      0x2B,0x29,0x27,0x25,0x23,0x21,0x1F,0x1D,
      0x1C,0x1A,0x19,0x17,0x16,0x14,0x13,0x12,
      0x11,0x10,0x0F,0x0E,0x0D,0x0C,0x0B,0x0A,
      0x0A,0x09,0x09,0x08,0x08,0x08,0x08,0x08,
      0x08,0x08,0x08,0x08,0x08,0x08,0x09,0x09,
      0x0A,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,
      0x11,0x12,0x13,0x14,0x16,0x17,0x19,0x1A,
      0x1C,0x1D,0x1F,0x21,0x23,0x25,0x27,0x29,
      0x2B,0x2D,0x2F,0x31,0x33,0x36,0x38,0x3A,
      0x3D,0x3F,0x42,0x44,0x47,0x4A,0x4C,0x4F,
      0x52,0x54,0x57,0x5A,0x5D,0x5F,0x62,0x65,
      0x68,0x6B,0x6E,0x71,0x74,0x77,0x7A,0x7D
   };


rom const char DENT_DE_SCIE_TABLE []={  // pour 1 periode !

    0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
    0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
    0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
    0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
    0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
    0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
    0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
    0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
    0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
    0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
    0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
    0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
    0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,
    0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,
    0x78,0x79,0x7A,0x7B,0x7C,0x7D,0x7E,0x7F,
    0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,
    0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
    0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,
    0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
    0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,
    0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
    0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
    0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
    0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
    0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
    0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
    0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
    0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
    0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
    0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
    0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};


rom const char CARRE_TABLE []={ // pour 1 periode!
           0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00

   };



 rom const char TRIANGLE_TABLE []={  // pour 1 periodes !
      0x08,0x09,0x0B,0x0D,0x0F,0x11,0x13,0x15,
      0x17,0x18,0x1A,0x1C,0x1E,0x20,0x22,0x24,
      0x26,0x27,0x29,0x2B,0x2D,0x2F,0x31,0x33,
      0x35,0x36,0x38,0x3A,0x3C,0x3E,0x40,0x42,
      0x44,0x45,0x47,0x49,0x4B,0x4D,0x4F,0x51,
      0x53,0x54,0x56,0x58,0x5A,0x5C,0x5E,0x60,
      0x62,0x63,0x65,0x67,0x69,0x6B,0x6D,0x6F,
      0x71,0x72,0x74,0x76,0x78,0x7A,0x7C,0x7E,
      0x80,0x81,0x83,0x85,0x87,0x89,0x8B,0x8D,
      0x8F,0x90,0x92,0x94,0x96,0x98,0x9A,0x9C,
      0x9E,0x9F,0xA1,0xA3,0xA5,0xA7,0xA9,0xAB,
      0xAD,0xAE,0xB0,0xB2,0xB4,0xB6,0xB8,0xBA,
      0xBC,0xBD,0xBF,0xC1,0xC3,0xC5,0xC7,0xC9,
      0xCB,0xCC,0xCE,0xD0,0xD2,0xD4,0xD6,0xD8,
      0xDA,0xDB,0xDD,0xDF,0xE1,0xE3,0xE5,0xE7,
      0xE9,0xEA,0xEC,0xEE,0xF0,0xF2,0xF4,0xF6,
      0xF8,0xF6,0xF4,0xF2,0xF0,0xEE,0xEC,0xEA,
      0xE9,0xE7,0xE5,0xE3,0xE1,0xDF,0xDD,0xDB,
      0xDA,0xD8,0xD6,0xD4,0xD2,0xD0,0xCE,0xCC,
      0xCB,0xC9,0xC7,0xC5,0xC3,0xC1,0xBF,0xBD,
      0xBC,0xBA,0xB8,0xB6,0xB4,0xB2,0xB0,0xAE,
      0xAD,0xAB,0xA9,0xA7,0xA5,0xA3,0xA1,0x9F,
      0x9E,0x9C,0x9A,0x98,0x96,0x94,0x92,0x90,
      0x8F,0x8D,0x8B,0x89,0x87,0x85,0x83,0x81,
      0x80,0x7E,0x7C,0x7A,0x78,0x76,0x74,0x72,
      0x71,0x6F,0x6D,0x6B,0x69,0x67,0x65,0x63,
      0x62,0x60,0x5E,0x5C,0x5A,0x58,0x56,0x54,
      0x53,0x51,0x4F,0x4D,0x4B,0x49,0x47,0x45,
      0x44,0x42,0x40,0x3E,0x3C,0x3A,0x38,0x36,
      0x35,0x33,0x31,0x2F,0x2D,0x2B,0x29,0x27,
      0x26,0x24,0x22,0x20,0x1E,0x1C,0x1A,0x18,
      0x17,0x15,0x13,0x11,0x0F,0x0D,0x0B,0x09
      };

#pragma

rom const float Coeff_DDS=0.022075794;  // 27 cycles pour 1 periode  Q=10Mhz x 4 (PLL ON)


rom const char chaine0[]="Frame Erreur et Overflow detection : ";
rom const char chaine1[]="Port comm 19200bds ouvert";
rom const char chaine2[]="Marquer 2% du signal";
rom const char chaine3[]="ESC pour sortir\r";
rom const char chaine4[]="Capture Taux sur ADC0 ";
rom const char chaine5[]=" Init Comparators 1 et 2 : ";
rom const char chaine6[]=" Facteur DDS AD9835 = "; 
rom const char chaine7[]=" Usage Q=10Mhz NO PLL !\r";
rom const char chaine8[]=" Erreur Saisie.....\r";
rom const char chaine9[]=" Init ConsFreq 1Khz\t";
rom const char chaine10[]=" Facteur DDS = ";
rom const char chaine11[]=" Interface via Terminal RS232 ET/OU via Joystick + LCD\r";
rom const char chaine12[]=" Gamme de 1 a 25.000Hz  \r";
rom const char chaine13[]=" 18F46K22_DDS_130419_ADC5b_AD9835_LCD_RS232_Joystick_C18.c\r";
rom char *Menu_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5,chaine6,chaine7,
                        chaine8,chaine9,chaine10,chaine11,chaine12,chaine13,};
                        
//rom const char DAC_Scale[][8]={"........"," 1.024V"," 2.048V"," 4.096V"};



#pragma romdata EEP1_=0xF00000

      rom unsigned char EEPROM_data [][32] ={
      //   1234567890123456789012345678901
          " 18F46K22 10Mhz Q=10Mhz      \r", //0 0   avec terminateur zero
          " Sinus                       \r", //1 20
          " Carre                       \r", //2 40 
          " Triangle                    \r", //3 60 
          " Dent de scie                \r", //4 80 
          " Reverse dent de scie        \r", //5 A0 
          " Rectangle f(Taux)           \r", //6 C0 
          " Reglage Taux Rectangle (pot)\r", //7 E0 
          " Reglage maxi sortie DAC Volt\r", //8 100
          " Choix Freq.PICDDS 1 parmi 63\r", //9 120 
          " Reglage Fin Frequence PICDDS\r", //10 140
          " Gestion DDS AD9835 SPI softw\r", //11 160
          " Reglage Freq DDS AD9835 a :  ", //12 180
          " Init sortie DAC maxi a :     ", //13 1A0
          " MPLAB IDE V8.90,C18 V3.44.  \r", //14 1C0
          " "Versus"  paulfjujo \r"             //15 1E0
          };
  #pragma
  #pragma romdata EEP2_=0xF00200
          rom unsigned char EEPROM_MSG [][16]={
   // tous les msg sont cadres sur 16 cars, donc sans terminateur zero !
         //1234567890123456
         // "Version 16/03/13",//0
          Versus,
          "     SINUS      ",//10   1
          "     Carre      ",//20   2
          "     Triangle   ",//30   3
          " Dents de SCIE  ",//40   4
          "rev Dent de SCIE",//50   5
          "    Rectangle   ",//60   6
          "Regl.TAUX Rectan",//70   7
          "                ",//80   8
          "Choix Freq Fixes",//90   9
          "Regl.Freq PICDDS",//A0   10
          "Mode DDS  AD9835",//B0   11
          "Regl.Freq AD9835",//C0   12
          "                ",//D0   13
          "F0 ou F1  AD9835",//E0   14
          "                " //F0   15
          };      
#pragma


#ifndef  LCD_DATAPORT 
// DATA_PORT defines the port to which the LCD data lines are connected 
#define LCD_DATAPORT       PORTB
#define LCD_DATAPORT_TRIS  TRISB        //4 upper bits only
//CTRL_PORT defines the port where the control lines are connected.
//ReadWrite Pin
#define LCD_RWPIN       PORTBbits.RB1       // not used
#define LCD_RWPIN_TRIS  TRISBbits.TRISB1    // not Used  RW connected to Gnd
//RS Pin
#define LCD_RSPIN       PORTBbits.RB2
#define LCD_RSPIN_TRIS  TRISBbits.TRISB2
//Enable Pin
#define LCD_ENPIN       PORTBbits.RB3
#define LCD_ENPIN_TRIS  TRISBbits.TRISB3
#endif

// DDS part .....
#define AD9835
#define FSYNC  PORTCbits.RC5    // RC5 pin 24 ... 8 DDS board
#define SCLK  PORTCbits.RC3     // RC3 pin 18 ....4 DDS Board 
#define SDATA PORTCbits.RC4     // RC4 pin 23 ... 3 DDS Board 
#define FLLSB 0x3000
#define FHLSB 0x2100
#define FLMSB 0x3200
#define FHMSB 0x2300
#define F0_LLSB 0x3000
#define F0_HLSB 0x2100
#define F0_LMSB 0x3200
#define F0_HMSB 0x2300
#define FREQ_1  0x0400
#define F1_LLSB 0x3400
#define F1_HLSB 0x2500
#define F1_LMSB 0x3600
#define F1_HMSB 0x2700
#define QUARTZ_DDS 50000000.0     //MHZ  quartz de la platine DDS
#define Const_Freq_AD9835  85.89934592    // = 2^32/Quartz_DDS
#define Butee_Mini_AD9835  86           // pour 1Hz
#define Butee_Maxi_AD9835  2147483562   // 25(Mhz)*max_32_bits/Quartz_AD(Mhz)

//#define  LCD_L1home    LCD_Cde(0x80)
//#define  LCD_L2home    LCD_Cde(0xC0)
//#define  LCD_Clear     LCD_Cde(0x01)
//#define  LCD_ReturnHome LCD_Cde(0x02)

#pragma udata GrossBank
static unsigned char buffer[128];
unsigned int Table_Freq [64]={
1,2,5,10,20,50,100,200,500,750,
1000,1250,1500,1750,2000,2500,2750,3000,3500,4000,
4500,5000,5500,6000,6500,7000,7500,8000,8500,9000,
9500,10000,11000,12000,13000,14000,15000,16000,17000,18000,
19000,20000,21000,22000,23000,24000,25000,26000,27000,28000,
29000,30000,31000,32000,33000,34000,35000,36000,37000,38000,
39000,40000,42500,45000
};

unsigned int Table_Progr_Taux[11]={
    0,1,2,10,25,50,100,250,500,750,1000};
unsigned int Table_Progr_Freq_Pic[11]={
    0,1,2,5,10,50,100,250,500,1000,5000};
unsigned long Table_Progr_Freq_AD[11]={
    0,1,5,10,50,100,500,1000,5000,10000,100000};    



#pragma udata

/*	Variables globales */
unsigned char  SIGNAL[256];




char *Ptr_Signal=&SINE_TABLE[0];       // pointeur sur table ROM
char Texte[80]="PROJET: 18F46K22_DDS_AD9835.mcp";
char *txt=&Texte[0];
unsigned char Entree[16]="123456789012345";
unsigned char *valtxt;
char *ptlec;		/* pointeur de lecture */
char *ptecr;		/* pointeur d'criture */
Byte Drapeau;
Byte receive;
char error;
char EtatCf;
signed char Ve;


unsigned int dummy;
volatile int CptFO,CptFE;           // compteur erreur UART
volatile unsigned char c;
unsigned short int i,j,k;
//int Scaling_DAC;
unsigned char s_count = 0;
unsigned int Mf,Mt;
int ChoixF;
unsigned int Taux;
unsigned int kk;
signed long ConsFreq=0L;
unsigned long Cons_DDS=0L ;
long FDDS[16];
float FConsDDS;
float FConsFreq;
float FFacteur_PIC;

float Tx;
float F1,F2,F3;
float FFacteur_AD9835;
float Freq_AD9835;
int SensAction;
int Step;
long Cp;
int DX;
int NbCarRef;


volatile int Pos_Menu_H;
volatile int CMP1,CMP2;
unsigned int MV,MH;
unsigned int Nt;
signed long Nf;

unsigned long M1,M2;
unsigned long ML=0L ;
struct ForByte
{
	near Byte pv0;
	near Byte pv1;
	near Byte pv2;
	near Byte pv3;
	} pV,ACCU,AD,DDS;

union {
    near unsigned long ACCUMULATEUR;
	near struct ForByte ACCU;
	}U1;

union
{
  near unsigned long Cons_DDS;
  near struct ForByte pV;
}MD;	

union {
    near unsigned long ML;
	near struct ForByte DDS;
	}U2;

volatile struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Over:1;
                 unsigned Elligible:1;
                 unsigned poubelle:1;
                 unsigned Blc:1;
                 unsigned Change:1;
                 unsigned Fill:1;
                 unsigned Lcd:1;
               }Drapeaux ;

volatile  union
{  unsigned char Fanion;
   struct chbits Drapeaux ;
} Flags;


#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;
#define Debugging PORTBbits.RB1
#define BP_Joystick PORTBbits.RB0    //BP valid via Pooling RB0  

volatile unsigned int count;
volatile unsigned int TimeEcoule;
volatile unsigned int OneSecond;
volatile unsigned int  Flag_IT_RB0;
unsigned int CptCars;
unsigned int SaisieOk;
unsigned int ESC;
unsigned char FREQ_E,FREQ_H,FREQ_M,FREQ_L;
unsigned ACC_E,ACC_H,ACC_M,ACC_L;


//---- declaration des sub ----------------
void LCD_Init(void);                            //to initialise the LCD
void LCD_Put(char data);                        //to put dtat to be displayed
void LCD_PutRamString(char *string);            //to display data string in RAM
void LCD_PutRomString(rom char *string);        //to display data stringin ROM
//char LCDIsBusy(void);                         //to check Busy flag
void LCD_Cde(unsigned char cmd);                //to send commands to LCD
//unsigned char LCDGetAddr(void);
//char LCDGet(void);
void Pulse_E (void);
void LCD_Pos(char L,char posX);
void LCD_Erase_Ligne(char L1);
void LCD_Delay15ms(void);
void LCD_Delay4ms(void);
void LCD_Delay100us(void);
void LCD_Delay500ns(void);
void LCD_Delay(void);
void SetCGRamAddr(unsigned char CGaddr);


//---- EEPROM PIC de 1024 bytes !!!
unsigned char EEPROM_Lect(unsigned int AdrL) ;
void EEPROM_Ecr(unsigned int AdrE,unsigned char car);
void Save_Msg_To_EEPROM(unsigned int * adrx, unsigned char * ptr1);
void PrintOut_Eeprom_Msg(unsigned int PtrE);


////--- local Softw RS232 ------
void Init_UART1(void);
void Put_RS(unsigned char c);
int PutStr_RS(char *s);
int PutStr_RS(char *s);
unsigned char Get_RS(void);
char *GetStr_RS(char *s, char finst);
void Raz_Receipt(void);

//---- Other subroutines
void Init_Hardware(void) ;
void Tempo(long int value);
void Idle(void);
void Octet2Hex(unsigned char number);
void Decompile_byte(Byte un);
void Write_Word(unsigned int M,char Sign);
void print_flt(float W,int NbDeci,char Bold);
void fltToa (float x, unsigned char *str,char precision);
void CRLF(void);
void copyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr);
void ReverseCopyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr);

//----- ADC 10 bit ------
void Init_ADC(void);
//void OpenADC( unsigned char config,unsigned char config2 );
void SetChanADC( unsigned char channel );
char BusyADC( void );		// 1= busy
void ConvertADC( void );
int ReadADC( void );
unsigned int Mesure_ADC(int j) ; // utilise buffer pointe par txt
void CloseADC( void );
void Config_DAC(void);

//--- interrupts
void Traite_ISR(void);

//- Clavier 5 boutons --
void Choix_Sinus(void) ;                   
void Choix_Carre(void) ;    
void Choix_Triangle(void);
void Choix_Dent_de_Scie(void);
void Choix_Reverse_Dent_de_Scie(void);  
void Choix_Rectangle(void);  
void  Calcule_et_Charge_consigne_DDS (signed long CF); 


void Init_Timer1(void);
void Init_Comparators(void);
void Config_DAC(void);
int Time_Elapsed(void);


//-- AD9835 -- SPI  serial write data
void AD9835_write_word(unsigned int AD_Word) ;
void AD9835_Charge_Freq(float F,unsigned int canal);
void Init_AD9835(void);
void Print_Decompose_32bits (unsigned long ML);


void Traite_Menu(void);
signed long Traite_Joystick_Freq (signed long Vin,signed long VMin,signed long VMax);
void  Refresh_Affichage_Consigne_Freq(void);
unsigned int Traite_Joystick_Taux (unsigned int Vi,unsigned int VMi,unsigned int VMa);
void Refresh_Affichage_Consigne_Taux(void);


// ---- init  interruptions ------------------------
// Serial Interrupt
#pragma code highvector=0x0008
void interrupt_at_high_vector(void)
{
_asm   goto Traite_ISR   _endasm
}
#pragma code

#pragma interrupt Traite_ISR
void Traite_ISR(void)	// reception d'une interruption
{
    //char c;
//==== UART interrupt ===========
if ( (PIE1bits.RC1IE == 1) &&(PIR1bits.RC1IF==1)) // si IT Rx UART
{
    c =Read1USART(); // le lire => RAZ  RCIF
   
     if(RCSTA1bits.FERR==1 )
   {
     RCSTA1bits.SPEN = 0 ;
     Flags.Drapeaux.FrameErr=1;
     CptFE++;
     RCSTA1bits.SPEN= 1 ;
     }
     else
     Flags.Drapeaux.FrameErr=0;

   if (RCSTA1bits.OERR==1)    // voir parag 16.1.26 p273
   {
       RCSTA1bits.CREN = 0 ;
       Flags.Drapeaux.Over=1;
       RCSTA1bits.CREN = 1 ;
       CptFO++;
       }
      else
      Flags.Drapeaux.Over=0;

   while( Busy1USART()) ; // par scurite
   //if (PORTBbits.RB1==0) Write1USART(c); // echo
	*ptecr++ = c;
	if (ptecr >= &buffer[SIZE]) ptecr = buffer;
	}
	
// =====  Timer1 interrupt ====
 if  (( PIE1bits.TMR1IE==1)&& (PIR1bits.TMR1IF==1))
 {
      count ++;
       if (count >= DureeCycle)  // x 0.1S=> XXsec
        {
         count=0;
         Flags.Drapeaux.Elligible=1;
        OneSecond ++;
       Led_Rouge=!Led_Rouge;
        }
      WriteTimer1(3035);    // 62500*8*0.2 => 200000S  =0,1sec
      PIR1bits.TMR1IF = 0;
  }
  //*--------- test si interrupt via RB0 --------------
 if ((INTCONbits.INT0IE==1) &&(INTCONbits.INT0IF==1))
 {  if (c==0)
     {
        c=27;
        PIE1bits.RC1IE =0;
        PIR1bits.RC1IF=0;
        ptecr = buffer;
        ptlec=ptecr;
     }   
   INTCONbits.INT0IF = 0;
   INTCONbits.INT0IE=0;
   PIE1bits.RC1IE =0; // stop IT Uart
   Flag_IT_RB0=1;
   Put_RS('@');
   }  
  
 //== comparators ============
 if   ((PIE2bits.C1IE==1)&&(PIR2bits.C1IF==1))
 {
    if(CM2CON1bits.MC1OUT==1) CMP1=1; 
    PIE2bits.C1IE=0;
    PIR2bits.C1IF=0;
    c=27;
    Put_RS('D');Put_RS(10);Put_RS(13);
    if (Debugging==1)Traite_Menu();
     
  }


  if ((PIE2bits.C2IE==1)&&(PIR2bits.C2IF==1))
 {
    if(CM2CON1bits.MC2OUT==1) CMP2=1; 
    PIE2bits.C2IE=0;
    PIR2bits.C2IF=0;
    c=27;
    Put_RS('G');Put_RS(10);Put_RS(13);
    if (Debugging==1)Traite_Menu();
  }
 
}

//===========================================

void AD9835_write_word(unsigned int AD_Word)    // serial write data
{
int caa;
FSYNC=0;
for (caa=16;caa>0;caa--) {

      if ((AD_Word&0x8000)==0)SDATA=0;else SDATA=1;
       Tempo(100); //delay_us(10);
       SCLK=1;
        Tempo(100); //delay_us(10);
      SCLK=0;
       Tempo(100); //delay_us(10);
      AD_Word= AD_Word << 1;

  }
 FSYNC=1;
}


void Init_AD9835()
{
 // init AD9835
AD9835_write_word(0xD000); //  RESET =1 via bit D12  et reset SYNC et SELSRC
Tempo(20000L);
// consigne pour 3000Hz
// Const_freq= 85,89934592
U2.ML= 0x0003EEA2;          //  257 698 avec Q=50MHz;
// charge registre 32 bits Freq0
AD9835_write_word(0x30A2);
AD9835_write_word(0x21EE);
AD9835_write_word(0x3203);
AD9835_write_word(0x2300);  // <- last byte of 4 bytes of 32bits word
Tempo(10000L);
AD9835_write_word(0x9000); // D15=1 D14=0 SYNC=0 SELSRC=1 acces source via programe et non via pins
AD9835_write_word(0xC000); // D15=1 D14=1 SLEEP=0 => Power up AD9835 , RESET=0 sort du mode reset
Tempo(10000L);
//Selecteur sur Freq0 pour Freq0=3000Hz
//Cde= C3=0 C2=1 C1=0 C0=1 => 5 pour acces D11, si D11=0 choix Freq0 => cde=0x5000
AD9835_write_word(0x5000);
Tempo(10000L);
}


void AD9835_Charge_Freq(float F,unsigned int canal)
{
  // init AD9835
AD9835_write_word(0xD000); //  RESET =1 via bit D12  et reset SYNC et SELSRC
Tempo(10000L);   
 U2.ML= (long) (F * FFacteur_AD9835);
 if (canal>0)
 {
 AD9835_write_word(F1_LLSB + U2.DDS.pv0);
 AD9835_write_word(F1_HLSB + U2.DDS.pv1);
 AD9835_write_word(F1_LMSB + U2.DDS.pv2);
 AD9835_write_word(F1_HMSB + U2.DDS.pv3);
 }
  else
   // delta de 0x0400 entre les commandes destinees a Freq1 et Fre0
  {
  AD9835_write_word(F0_LLSB + U2.DDS.pv0);
  AD9835_write_word(F0_HLSB + U2.DDS.pv1);
  AD9835_write_word(F0_LMSB + U2.DDS.pv2);
  AD9835_write_word(F0_HMSB + U2.DDS.pv3);
 }
 Tempo(10000L);
//AD9835_write_word(0x2300);  // removed 29/03/2013
AD9835_write_word(0x9000); // D15=1 D14=0 SYNC=0 SELSRC=1 acces source via programe et non via pins
AD9835_write_word(0xC000); // D15=1 D14=1 SLEEP=0 => Power up AD9835 , RESET=0 sort du mode reset
Tempo(10000L);
//Selecteur sur Freq0 pour Freq0=3000Hz
//Cde= C3=0 C2=1 C1=0 C0=1 => 5 pour acces D11, si D11=0 choix Freq0 => cde=0x5000
AD9835_write_word(0x5000);
Tempo(10000L);
}


void Print_Decompose_32bits (unsigned long  Mx)
{unsigned long ML2;
 ML2 =Mx;  
 ultoa(ML2,&Texte[0]);
 k=PutStr_RS(Texte);
 Put_RS(TAB);
 Octet2Hex(ML2 & 0x000000FF); Put_RS(TAB);
 ML2=ML2 >>8;
 Octet2Hex(ML2 & 0x000000FF); Put_RS(TAB);
 Octet2Hex(ML2); Put_RS(TAB);
 ML2=ML2>>8;
 Octet2Hex(ML2 & 0x000000FF); Put_RS(TAB);
 ML2=ML2>>8;
 Octet2Hex(ML2); Put_RS(TAB);
 CRLF();
}

//--------- RS232 local software --------------

void Init_UART1(void)
{
// USART_BRGH_HIGH,32
// init 38400Bd a 20Mhz
// init 19200Bd a 10Mhz avec IT en rx
// voir para 18.5 spec sheet DS41159B page 186
// 19200  64  @ 20MHz
// 38400  32  @ 20MHz
// 38400  64  @ 40Mhz  (Q=10Mhz x PLL=4)
// 115200  21 @ 40Mhz

Open1USART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
//USART_CONT_RX &
USART_SINGLE_RX &
//USART_BRGH_HIGH,64      //38400 bds
USART_BRGH_HIGH,128      //19200 bds
);
IPR1bits.RC1IP=1;  // high priority for UART
RCONbits.IPEN = 1;     // Enable High interrupt priority model.
PIE1bits.RC1IE = 0;
INTCONbits.PEIE = 0 ; // autorisation des IT des priphriques
INTCONbits.GIE = 0 ; // autorisation globale des IT
}

int PutStrR_RS(rom char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}


int PutStr_RS(char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}

void Put_RS(unsigned char untel)
{
   	while(Busy1USART());
   	//putc1USART(untel);
   	Write1USART(untel);
}

void CRLF()
{
  Put_RS(CR);  Put_RS(LF);
  }

unsigned char Get_RS(void)
	{
	unsigned char c;
	while (ptlec == ptecr);
	c = *ptlec++;
	if (ptlec >= &buffer[SIZE])	ptlec = buffer;
	return (c);
	}





//------  EEPROM  PIC 18FX6K22  1024 bytes !!------------

unsigned char EEPROM_Lect(unsigned int AdrL) 
{ 
    EEADR =(unsigned char)(AdrL&0x00FF);
    EEADRH =(unsigned char) ((AdrL>>8)& 0x03);   //Bits 3-7 are masked off since EEPROM is only 1KB
//	EEADR=(Hi)AdrL;
//	EEADR=(low)AdrL;
	EECON1bits.EEPGD=0;     // 0= adressage EEPROM
	EECON1bits.CFGS=0;      // 0= acces data EEPROM
	EECON1bits.RD=1;        // arme Lecture EEprom
	 Tempo(1000L);
	return(EEDATA);
}

void EEPROM_Ecr(unsigned int AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr;
    
    if (Drapeaux.Lcd) AdrE=AdrE + 0x02;
    EEADRH = ((AdrE>>8)&0x03);   //Bits 2-7 are masked off since EEPROM is only 1KB
    EEADR =(AdrE &0xFF);
	EEDATA=car;
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;            // autorise ecriture EEPROM
	EECON1bits.CFGS =0;
  if(INTCONbits.GIE ==1)
    {
    INTCONbits.GIE =0 ;
    dr=1;
    }
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	while (PIR2bits.EEIF==0);
	PIR2bits.EEIF=0;
	EECON1bits.WREN=0;
	if (dr==1)INTCONbits.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned int * adrx, unsigned char * ptr1)
{
	while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(unsigned int PtrE)
{ // imprime  N de msg en eeprom until carcatere=0 ou 15 cars maxi si choix LCD
  int i,j;
  // calcule adresse offset du msg 
    if (Drapeaux.Lcd==1) PtrE=(PtrE<<4)+0x0200; else PtrE=PtrE<<5;
    // Numero de msg *16 car pour LCD
    // numero Msg *32 car pour ecran RS232
  j=0;
  do
  {
  if ( PtrE >1023) break;
  i = (int)EEPROM_Lect(PtrE);
  if ( i==0) break;
  if ((Drapeaux.Lcd==1) && (j>15)) break;  // msg cadres sur 16 bytes !!
  if(Drapeaux.Lcd==0) Put_RS((Byte)i); else LCD_Put((Byte)i);
  PtrE++;j++;
  }
  while (i!=0)  ;
 Tempo(1000L);
}



/*
void Write_Word(unsigned int M)     // entier cadre sur 5 digits complet par des zeros a gauche
{
 unsigned int k,L;
 valtxt=&Entree[0];
 itoa(M,valtxt);
 k=strlen(valtxt);
 for (L=k;L<4;L++) 
 { 
     if(Drapeaux.Lcd==0)Put_RS('0');  else LCD_Put('0');
 } 
 if(Drapeaux.Lcd==0) k=PutStr_RS(valtxt);else  LCD_PutRamString(valtxt); 
}
*/


void Write_Word(unsigned int M,char Sign)
{
unsigned int i,k,l;
unsigned long M1;
 valtxt=&Entree[0];
 if (Sign>1) return;
 if (Sign==0)
  {       M1=(long)M;
        ultoa(M1,valtxt);
  }
  else itoa(M,valtxt);
 if (Flags.Drapeaux.Fill==1)
 {
  k=strlen(valtxt);
  for (i=0;i<k;i++) Entree[4+Sign-i]=Entree[k-i-1];
  for (i=0;i<(5+Sign-k);i++)
  {if (Flags.Drapeaux.Blc==1) Entree[i]='0'; else Entree[i]=' ';}
 }
 Entree[5+Sign]=0;
 if (Drapeaux.Lcd)
  LCD_PutRamString(valtxt);
   else
 k=PutStr_RS(valtxt);
}

void fltToa (float x, unsigned char *str,char precision)
{
/* converts a floating point number to an ascii string */
/* x is stored into str, which should be at least 30 chars long */
unsigned char *adpt;
int ie, i, k, ndig;
double y;
adpt=str;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;
/* if x negative, write minus and reverse */
if ( x < 0)
  {
  *str++ = '-';
  x = -x;
  }
/* put x in range 1 <= x < 10 */
if (x > 0.0) while (x < 1.0)
  {
  x *= 10.0;		// a la place de =*
  ie--;
  }
while (x >= 10.0)
  {
  x = x/10.0;
  ie++;
 }
 ndig += ie;				// a la place de =+
//round. x is between 1 and 10 and ndig will be printed to
// right of decimal point so rounding is ...
for (y = i = 1; i < ndig; i++)
  y = y/10.;
x += y/2.;
if (x >= 10.0) {x = 1.0; ie++;}
if (ie<0)
  {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
  }
for (i=0; i < ndig; i++)
  {
  k = x;
  *str++ = k + '0';
  if (i ==  ie ) *str++ = '.';
  x -= (y=k);
  x *= 10.0;
  }
*str = '\0';
//return (adpt);
}


void print_flt(float W,int NbDeci,char Bold) // avec NbDeci=1,100,1000,10000
{long lWhole;
 unsigned int ulPart;
 Drapeaux.Fill=0;
 lWhole=(long)(W);
 ulPart=(unsigned int)( (float) NbDeci*(W - (float) lWhole));
 ultoa(lWhole,&Texte[0]);
 if (Drapeaux.Lcd==1) LCD_PutRamString(Texte);else k=PutStr_RS(Texte);
 if (Drapeaux.Lcd==1) LCD_Put('.'); else  Put_RS('.');
 Write_Word(ulPart,0);
}

void Decompile_byte(Byte un) {
Byte masque;
  masque = 0x80;
  while (masque > 0u )
 {
  if (un & masque)
      Put_RS(49u);  //  '1'
    else
      Put_RS(48u);  //  '0'

    masque =masque >>1;
     }
}

void Octet2Hex(unsigned char number)
{
char high,low;
  low=0;
  // high nibble
  high = ((number & 0xF0) >> 4) + 48; // + '0'
  if (high > '9')    high =high + 7;
 // low nibble
  low = (number & 0x0F) + 48;          // +'0' low nibble
  if (low > '9')  low += 7;                        // '9'= 57u
  if(Drapeaux.Lcd==0)
   {
    Put_RS(high);   
    Put_RS(low);
    Put_RS('h'); 
   }
   else
   {
    LCD_Put(high);  
    LCD_Put(low); 
    LCD_Put('h');
    } 
}

void Tempo(long val)
{
while(val>0){val--;}
}

void Remplis_N_blancs(Byte N)
{int i;
 for (i=0;i<N;i++)  Put_RS(' ');
}


void Config_DAC(void)
{
// init DAC 5bits output
VREFCON0=0x00;
VREFCON0bits.FVREN=1;       // valid Fixed REF. Voltage
VREFCON0bits.FVRS1=1;       // Voltage ref= 4.096V
VREFCON0bits.FVRS0=1;
//VREFCON0bits.FVRS=Scaling_DAC;
txt=&Texte[0];
//strcpypgm2ram(txt,DAC_Scale[Scaling_DAC]);
strcpypgm2ram(txt," 4.096V");
if(Drapeaux.Lcd==1)
{   LCD_Erase_Ligne(2);
    LCD_PutRamString(txt); 
    }
    else 
    {
     k=PutStr_RS(txt);CRLF(); 
        }
Tempo(1000L);
VREFCON1bits.DACEN=1 ;      // valide DAC
VREFCON1bits.DACLPS=0;      // sortie a 0 en mode Low Power
VREFCON1bits.DACOE=1;       // sortie DAC sur PIN
VREFCON1bits.DACPSS1=1;     // DAC positive source is FVR Buff1 output
VREFCON1bits.DACPSS0=0;
VREFCON1bits.DACNSS=0;      // DAC Negative source is 0V VSS
VREFCON2=0x00;              // output level=0
}




void Init_Comparators(void)
{
      // RA1 analog input compare to R3 anlog input & Vfref 4,096V
 
     PMD2bits.CMP1MD=0;   // Enabled comparator 1
     CM1CON0bits.C1ON=0; 
     CM1CON0bits.C1POL=0;
      CM1CON0=0b11001001;    // Vin- sur RA1  Vin+ sur RA3   
     //CM1CON0bits.C1ON=1;  // enable Comparator 1
     //CM1CON0bits.C1OUT=1; // inverted polarity  
     //CM1CON0bits.C1OE=0;  // internaly only
     //CM1CON0bits.C1POL=0; // logic not inverted
     //CM1CON0bits.C1SP=1 ; //C1 in normal power
     //CM1CON0bits.C1R=0;   //C1VIN+ connected to PIN C1IN+ (=RA3)
     //CM1CON0bits.C1CH1=0; 
     //CM1CON0bits.C1CH0=1; // Vin- = RA1

     PMD2bits.CMP2MD=0;   // Enabled comparator 2
     CM2CON0bits.C2ON=0; 
     CM2CON0bits.C2POL=0;
     CM2CON0=0b11011101;    // Vin- sur RA1 Vin+ sur Vref
     //CM2CON0bits.C2ON=1;  // enable Comparator 2
     //CM2CON0bits.C2OUT=1; // inverted polarity
     //CM2CON0bits.C2OE=0;  // internaly only
     //CM2CON0bits.C2POL=1; // logic  inverted
     //CM2CON0bits.C2SP=1 ; //C2 in normal power
     //CM2CON0bits.C2R=1;   //C2VIN+ connected to C2VREF
     //CM2CON0bits.C2CH1=0;  
     //CM2CON0bits.C2CH0=1;  //C2IN1- pin of C1 connected to C2VIN-
 

     CM2CON1bits.C1RSEL=1; // FVR Buf1 connected to C1VREF input
     CM2CON1bits.C2RSEL=1; // FVR Buf1 connected to C2VREF input
     CM2CON1bits.C1HYS=0; //Hysteresis disabled
     CM2CON1bits.C2HYS=0;
     CM2CON1bits.C1SYNC=0; // asynchronous
     CM2CON1bits.C2SYNC=0;
     
     PIE2bits.C1IE=0; // disable IT
     PIE2bits.C2IE=0; // disable IT
     IPR2bits.C1IP=1; // priority haute
     IPR2bits.C2IP=1;
 }


void Init_Hardware()
{  
  PORTA = 0X00;
  ANSELA=0;
  ANSELAbits.ANSA0=1;    //  analog input on RA0   voir page 154
  ANSELAbits.ANSA1=1;    //  analog input on RA1 
  ANSELAbits.ANSA2=1;    //  analog input on RA2 
  ANSELAbits.ANSA3=1;   //  analog input on RA3
  TRISA = 0b00001111 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC5b,  RA3,4,5=Digital output
   
  PORTB = 0xFF;
  ANSELB=0;
  TRISB = 0x03;    // RB0,RB1 as input, others as ouput  ATTENTION B7 B6 for ICSP Pickit3
  WPUB=0x02;               // any pin pull up
  INTCON2bits.RBPU=0;  
 
  PORTC = 0xFF;          // RC0..RC5=Output
  ANSELC=0;
  TRISC = 0b10000000;    // 
  TRISCbits.TRISC6 = 0;  // TX - UART1
  TRISCbits.TRISC7 = 1;  // RX - UART1

 //only for 18F46K22 
  PORTD=0x00;
  ANSELD=0 ;   // No Analog
  TRISD=0b10111111;  //0xBF  all input  except D6as output for TX UART2
  
  PORTE=0;
  ANSELE=0;
  TRISE=0x00;  // all outputs

  SLRCON=0; // standard rate for PORTA,B,C,D,E
  

 }


void Init_ADC()
 {
       //config lecture ADC 10 bits
 ADCON0bits.ADON=1;      // ADC enabled chanel 0
 ADCON1bits.TRIGSEL=0 ; // trigger from CCP5
 ADCON2bits.ADFM=1;     // right justified
 ADCON2bits.ACQT2=1;
 ADCON2bits.ACQT1=1;
 ADCON2bits.ACQT0=0;    // 16 TAD
 ADCON2bits.ADCS1=1;    // select RA0 = analog input
 ADCON2bits.ADCS2=0;    // RA1 = Analog input
 ADCON2bits.ADCS0=0;    // Fosc/32
 ADCON1bits.PVCFG1=0;   // +Vref = +5V AVdd
 ADCON1bits.PVCFG0=0;
 ADCON1bits.NVCFG1=0;   // -Vref = Gnd AVss
 ADCON1bits.NVCFG0=0;
 }


 unsigned int Mesure_ADC(int j) // utilise buffer pointe par txt
{
  unsigned int M0;
  ADCON0=1 + (j<<2);    // ADON=1 et choix de canal
  Delay10TCYx( 10 );    // Delay for 100TCY
  ConvertADC();         // Start conversion
  while( BusyADC() );
  M0 = ReadADC();       // Read result
  return (M0);
}

void Init_Timer1()
{
 //--- init timer
 //see PIC18F25K22_46K22_41412E.pdf  12.13 page 172
  T1CONbits.TMR1CS1=0;
  T1CONbits.TMR1CS0=0; // clock source= Fosc/4
  T1CONbits.T1CKPS1=1;
  T1CONbits.T1CKPS0=1; // prescaler =1/8
  T1CONbits.T1SOSCEN=0; // Secondary Oscillator Disabled
  T1CONbits.T1SYNC=0;   // Synchro extern clock input with Fosc  (ignore)
  T1CONbits.T1RD16=1 ;  // Mode 16 bits
  T1CONbits.TMR1ON=0;   // Stop timer1
  //---
  T1GCONbits.TMR1GE=0;  // allways count if TMR1ON=1
  T1GCONbits.T1GTM=0;   // Toogle Gate mode disabled
  T1GCONbits.T1GSS1=0;  // Timer1 gate pin
  T1GCONbits.T1GSS0=0;
  //----
  IPR1bits.TMR1IP=1;      // set hihh priority for Timer1
  RCONbits.IPEN = 1;      // Enable High interrupt priority model.
  PIE1bits.TMR1IE=0;      // disable Interrupt Timer1
  WriteTimer1(3035);      // 62500*8*4*0.025 => 50S (@40Mhz)
  PIR1bits.TMR1IF=0;      // raz flag interrupt
  INTCONbits.PEIE = 1;    // enable interupt Peripheriques
  T1CONbits.TMR1ON=0;     // desactive Timer1
  INTCONbits.GIE = 1;     // active global interrupt
  INTCONbits.GIEL=1;      // active les priorites  (par8 page 79 docu PIC18Fxx8)
  OneSecond=0;
}

void copyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr)
{
int i;
i=0;
do
{
*Ramptr++=*Romptr++;
i++;
}while (i<256);
}

void ReverseCopyRom2Ram(unsigned char *Ramptr,rom unsigned char *Romptr)
{
int i;
i=0;
do
{
*(Ramptr+255-i)=*Romptr++;
i++;
}while (i<256);
}


void Calcule_et_Charge_consigne_DDS (signed long CF)
{
    // calcul equivalent binaire consigne DDS sur 24 bits ( 3 octets)
    // on passe en flottant pour les calculs !
        FConsFreq= (float )CF;
        FFacteur_PIC=Coeff_DDS;  //  =(nb_sinusoides*1000000)/(Tr_de_boucle*bin24_bits)
        FConsDDS=  FConsFreq / FFacteur_PIC;    // Calcul consigne DDS pour obtenir Freq Out
        MD.Cons_DDS= (long) ceil(FConsDDS); // rangement dans un long 32 bits
       // ultoa(MV.Cons_DDS,&Texte[0]);       // verification en ascii
       // k=PutStr_RS(Texte);
        OUT_LCD
        LCD_Erase_Ligne(2);
        if (Pos_Menu_H==9) 
        {
            LCD_Put((char)(ChoixF/10)+48);LCD_Put((char)(ChoixF%10)+48);LCD_Put(' ');LCD_Put(' ');
            //Octet2Hex((char)ChoixF);
            LCD_Pos(2,6);
        }
      //  ultoa(MV.Cons_DDS,&Texte[0]);       // verification en ascii
      //  LCD_PutRamString(Texte);           //
        fltToa (FConsFreq,txt,1);
        LCD_PutRamString(txt);  LCD_Put(' ');LCD_Put('H');LCD_Put('z');
        OUT_RS232
        k=PutStr_RS(txt);
        Put_RS('H');Put_RS('z');
        CRLF();
        OUT_LCD
      // affiche les 4 octets correspondants
      //  Write_Word(MV.pV.pv3);Put_RS(TAB); // ESB not used
      //  Write_Word(MV.pV.pv2);Put_RS(TAB); // HSB
      //  Write_Word(MV.pV.pv1);Put_RS(TAB); // MSB
      //  Write_Word(MV.pV.pv0);Put_RS(TAB); // LSB
     // rangement de la consigne DDS dans les 3 octets FREQ_xx
        FREQ_L= MD.pV.pv0;
        FREQ_M= MD.pV.pv1;
        FREQ_H= MD.pV.pv2;
        U1.ACCUMULATEUR=0;
}
       
void Raz_Receipt()
{ptecr=buffer;
      ptlec= ptecr;
      CptCars=0;
      c=0;
      receive=0;
 }   
 
         

void Choix_Sinus()
{ 
  if (Drapeaux.Lcd)LCD_Erase_Ligne(1);
  PrintOut_Eeprom_Msg(1);
            for (i=0;i<256;i++)
            {
             F1=(float)SINE_TABLE[i]/8.0;
             SIGNAL[i]=(char)(F1);
            }
}
                 
void Choix_Carre()
{
    if (Drapeaux.Lcd)LCD_Erase_Ligne(1);
    PrintOut_Eeprom_Msg(2);
             for (i=0;i<128;i++) SIGNAL[i]=31;
             for (i=128;i<256;i++) SIGNAL[i]=0;
}                       
    
void Choix_Triangle()
{
     if (Drapeaux.Lcd)LCD_Erase_Ligne(1);
     PrintOut_Eeprom_Msg(3);
            for (i=0;i<128;i++)
            {
             F1=(float)i/4.0;
             SIGNAL[i]=(char)(F1);
            }
             for (i=128;i<256;i++)
            {
             F1=(float)(255-i)/4.0;
             SIGNAL[i]=(char)(F1);
            }
 }
 
 void Choix_Dent_de_Scie()
 {
     if (Drapeaux.Lcd)LCD_Erase_Ligne(1);
     PrintOut_Eeprom_Msg(4);
             for (i=0;i<256;i++)
            {
             F1=(float)i/8.0;
             SIGNAL[i]=(char)(F1);
            }
 }
     
 void Choix_Reverse_Dent_de_Scie()
 {
     if (Drapeaux.Lcd)LCD_Erase_Ligne(1);
     PrintOut_Eeprom_Msg(5);
             for (i=0;i<256;i++)
            {
             F1=(float)(255-i)/8.0;
             SIGNAL[i]=(char)(F1);
            }
  }
  
  void Choix_Rectangle()
  {   unsigned int R;
      R=Taux>>2;
      if (Drapeaux.Lcd)LCD_Erase_Ligne(1);
      PrintOut_Eeprom_Msg(6);
      if ((R>0)&&(R<255))
        {
             // duree etat HAUT !
               for (i=0;i<R;i++)  SIGNAL[i]=31;
             // duree etat BAS !
               for (i=R;i<256;i++) SIGNAL[i]=0;
        }       
  }    
  

void  Refresh_Affichage_Consigne_Freq()
{
       LCD_Put(' '); 
       LCD_Pos(2,6);
         F1= (float )Nf;
         txt=&Texte[0];
         fltToa (F1,txt,1);
         if(Pos_Menu_H==11)
           {    LCD_Pos(2,3);
               j=10-strlen(txt);  // up to 20000000.0 Hz
               }
               else
               {
                 j=7-strlen(txt);  // up to 25000.0 Hz
                 LCD_Pos(2,6);
                 }
         while(j-->0)LCD_Put(' ');
         LCD_PutRamString(txt);  LCD_Put(' ');LCD_Put('H');LCD_Put('z');  
         Tempo(5000); // vitesse d'evolution 
 }        

   
signed long Traite_Joystick_Freq (signed long Vin,signed long VMin,signed long VMax)
 {
 unsigned  int Mf;

 signed long k;
 unsigned int j;
 Nf=Vin;
 while(BP_Joystick==0);
 do
 {

 j=0;
 T1CONbits.TMR1ON=0;
 PIR1bits.TMR1IF = 0;
 count=0;
 Mf=Mesure_ADC(0); 
 Tempo(2000); 
 if ((Mf <= 700)&&(Mf>=300) )
 {       
         Led_Up=1; Led_Down=1; //eteint les 2 leds
         Led_Centre=0;
         LCD_Pos(2,0);
         LCD_Put('=');
         Refresh_Affichage_Consigne_Freq(); 
         count=0;
 }   
  
 if(Mf>700)
  {   Led_Up=0;Led_Centre=1;Led_Down=1;
        count=0;
        while (Mf>700)
        {
         Mf=Mesure_ADC(0);   
         count++;
         j=count>>3;
         if (j>10) j=10;
         if(Pos_Menu_H==11)k= Table_Progr_Freq_AD[j]; else k=(long) Table_Progr_Freq_Pic[j];
         if ((Nf+k)< VMax) Nf=Nf+k; else Nf=VMax;
          OUT_LCD
         LCD_Pos(2,0);
         LCD_Put('>');
          Refresh_Affichage_Consigne_Freq(); 
        }
  } // if Mf>700  
     
  if(Mf<300)
 {   Led_Up=1;Led_Centre=1;Led_Down=0;   // 0=Allume!
        count=0;
        while (Mf<300)
        {
            count ++;
            Mf=Mesure_ADC(0);  
         j=count>>3;
         if (j>10) j=10;
         if(Pos_Menu_H==11)k= Table_Progr_Freq_AD[j]; else k=(long) Table_Progr_Freq_Pic[j];
         //if(( Nf-k)> VMin) Nf=Nf-k; else Nf=VMin;
         if ( Nf > (k+VMin)) Nf=Nf-k; else Nf=VMin;
         LCD_Pos(2,0);
         LCD_Put('<');
         Refresh_Affichage_Consigne_Freq(); 
        }
  } // if < 300    

}
while(BP_Joystick==1);
Tempo(5000);
while(BP_Joystick==0);
OUT_RS232
txt=&Texte[0];
F1= (float )Nf;
fltToa (F1,txt,1);
k=PutStr_RS(txt);
CRLF();
OUT_LCD
return(Nf);
}  


void Refresh_Affichage_Consigne_Taux()
{
 LCD_Put(' '); 
 LCD_Pos(2,7);
 Tx=(float)Nt*100.0/1024.0;
 fltToa (Tx,txt,1);
 LCD_PutRamString(txt); 
    Tempo(10000);    
}  
  
unsigned int Traite_Joystick_Taux (unsigned int Vin, unsigned int VMint, unsigned int VMaxt)
 {
 unsigned  int Mt,k;
 Nt=Vin;
 T1CONbits.TMR1ON=0; 
 OUT_LCD
 LCD_Erase_Ligne(2);
 do
 {
 count=0;
 j=0;
 Mt=Mesure_ADC(0); 
 Tempo(2000); 
if ((Mt <= 750)&&(Mt>=250))
 { 
      
      Led_Up=1; Led_Down=1; //eteint les 2 leds
      Led_Centre=0;
      LCD_Pos(2,0); LCD_Put('=');
      Refresh_Affichage_Consigne_Taux();
      count=0;
      j=0;
 } 
     
if (Mt>750)
  {   count=0;
      Led_Up=0;Led_Centre=1;Led_Down=1;
      while (Mt>750)
      {
       
        Mt=Mesure_ADC(0);
        count ++;
        j=count>>3;
        if (j>10) j=10;
        if(Pos_Menu_H==11)k= Table_Progr_Taux[j]; else k=Table_Progr_Taux[j];
        if ((Nt+k)< VMaxt) Nt=Nt+k; else Nt=VMaxt;
        LCD_Pos(2,0);
        LCD_Put('>');
        Refresh_Affichage_Consigne_Taux();
    }
  } // if Mt >750      

 if (Mt<250)
  { count=0;
    while (Mt<250)
    {
        Led_Up=1;Led_Centre=1;Led_Down=0;
        count ++;
        Mt=Mesure_ADC(0);  
        j=count>>3;
        if (j>10) j=10;
        if(Pos_Menu_H==11)k= Table_Progr_Taux[j]; else k=Table_Progr_Taux[j];
        if ((Nt-k)> VMint) Nt=Nt-k; else Nt=VMint;
        OUT_LCD
        LCD_Pos(2,0);
        LCD_Put('>');
        Refresh_Affichage_Consigne_Taux();
     }

 } //mt<250
}
while(BP_Joystick==1);
Tempo(5000);
while(BP_Joystick==0);
OUT_RS232
Tx=(float)Nt*100.0/1024.0;
fltToa (Tx,txt,2);k=PutStr_RS(txt);
CRLF();
OUT_LCD
return(Nt);
}  
  
  
int  Time_Elapsed()
{
 int j;
        // on dispose de 4 secondes (3,2,1,0) pour appuyer sur le BP valid
        // pour rentrer dans le mode reglage 
             OUT_LCD
             LCD_Erase_Ligne(2);
             OneSecond=0;
             Init_Timer1();
             T1CONbits.TMR1ON=1;     // active Timer1
             PIR1bits.TMR1IF=0;
             PIE1bits.TMR1IE=1;      // Enable Interrupt Timer1
             j=0;
             do
             {
              LCD_Pos(2,0); LCD_Put(51-OneSecond);  // 51= '3'
              if (BP_Joystick==0) 
              {   PIE1bits.TMR1IE=0;
                  j=1;
                  OneSecond=3;  
                  LCD_Pos(2,1);LCD_Put(' '); 
                  }     
            } while (OneSecond<3);
            PIE1bits.TMR1IE=0;
            T1CONbits.TMR1ON=0;     // desactive Timer1
            PIR1bits.TMR1IF=0;  
            count=0;
            while(BP_Joystick==0);// attente relache BP
return (j);
}
   
void Traite_Menu()
{
 int i,jt;
    PIE2bits.C1IE=0; 
    PIE2bits.C2IE=0; 
 OUT_LCD
   if (CMP1==1)  // droite
    {   
       Pos_Menu_H++;
       if (Pos_Menu_H>Max_Pos_Menu) Pos_Menu_H=1;
      // if (Pos_Menu_H<Max_Pos_Menu) Pos_Menu_H++;
        Tempo(15000L);
        Put_RS('D');Put_RS(10);Put_RS(13);
     }
    if (CMP2==1) // gauche
    {     
       Pos_Menu_H--;
       if (Pos_Menu_H==0) Pos_Menu_H=Max_Pos_Menu;
      // if (Pos_Menu_H>1) Pos_Menu_H--;
        Tempo(15000L);
        Put_RS('G');Put_RS(10);Put_RS(13);
     }
     switch (Pos_Menu_H)
     {
            case 1 :
            {
             Choix_Sinus();
             break;
            }     
            
            case 2 :
            {
             Choix_Carre();
                break;
            } 
            case 3 :
            {
             Choix_Triangle();
               break;
            } 
            case 4 :
            {
             Choix_Dent_de_Scie();
              break;
            } 
            case 5 :
            {
             Choix_Reverse_Dent_de_Scie();
              break;
            } 
            case 6 :
            {
             Choix_Rectangle();
             
             // on dispose de 5 secondes pour appuyer sur le BP valid
             // pour rentrer dans le mode reglage Taux
             OUT_LCD
             LCD_Erase_Ligne(2);
             fltToa (FConsFreq,txt,1);
             LCD_PutRamString(txt);  LCD_Put(' ');LCD_Put('H');LCD_Put('z');
             OUT_RS232
             k=PutStr_RS(txt);
             Put_RS('H');Put_RS('z');
                       
            jt=Time_Elapsed();
            if (jt>0)
            {
                     
             OUT_LCD
             LCD_Erase_Ligne(1);
             PrintOut_Eeprom_Msg(7);// reglage Taux
             LCD_Erase_Ligne(2);
             LCD_Pos(2,7);
             Tx=(float)Taux*100.0/1024.0;
             fltToa (Tx,txt,2);
             LCD_PutRamString(txt);
             i=0;
             Tempo(50000);
             
             Taux= Traite_Joystick_Taux (Taux,2,1022);
             }
             
             OUT_LCD
             LCD_Erase_Ligne(1);
             PrintOut_Eeprom_Msg(6);// rectangle
             Choix_Rectangle(); // met a jour la forme rectangle
             LCD_Erase_Ligne(2);
             LCD_Pos(2,7);
             Tx=(float)Taux*100.0/1024.0;
             fltToa (Tx,txt,2);
             LCD_PutRamString(txt);
             OUT_RS232
             PrintOut_Eeprom_Msg(7);// taux
             k=PutStr_RS(txt);CRLF();
             OUT_LCD 
             break;
            } 
            case 7 :Pos_Menu_H=8;
            case 8: Pos_Menu_H=9;
          
            case 9 :  // choix 1 frequence parmi 64  Freq fixes
             {              
                 LCD_Erase_Ligne(1);
                 PrintOut_Eeprom_Msg(9);// choix Freq
                 ConsFreq=Table_Freq[ChoixF];
                 LCD_Erase_Ligne(2);
                 LCD_Put((char)(ChoixF/10)+48);LCD_Put((char)(ChoixF%10)+48);LCD_Put(' ');LCD_Put(' ');
                 LCD_Pos(2,6);
                 FConsFreq= (float )ConsFreq;
                 fltToa (FConsFreq,txt,1);
                 LCD_PutRamString(txt);  LCD_Put(' ');LCD_Put('H');LCD_Put('z'); 
                 jt=Time_Elapsed();
                if (jt>0)
                {
                          
                    i=0;
                    LCD_Erase_Ligne(2);
                    do
                     {
                    MV=Mesure_ADC(0);
                    if (MV> 750)
                    { ChoixF++;
                    if(ChoixF>63) ChoixF=1;
                    }    
                     if (MV< 250)
                    {   ChoixF--;
                     if(ChoixF<1)  ChoixF=63;
                    }    
                    ConsFreq=Table_Freq[ChoixF];
                    LCD_Erase_Ligne(2);
                    LCD_Put((char)(ChoixF/10)+48);LCD_Put((char)(ChoixF%10)+48);LCD_Put(' ');LCD_Put(' ');
                    LCD_Pos(2,6);
                    FConsFreq= (float )ConsFreq;
                    fltToa (FConsFreq,txt,1);
                    LCD_PutRamString(txt);  LCD_Put(' ');LCD_Put('H');LCD_Put('z');                  
                    Tempo(150000L);
                 } 
                while(BP_Joystick==1 );
                Tempo(5000);
                while(BP_Joystick==0 );
                }
                break; 
              } 
              case 10 :  // reglag  freq par potar
             {
                 LCD_Erase_Ligne(1);
                 PrintOut_Eeprom_Msg(10);// reglage Freq
                 LCD_Erase_Ligne(2);   
                 
                 jt=Time_Elapsed();
                 if (jt>0) 
                 {
                  ConsFreq=Traite_Joystick_Freq (ConsFreq,1,25000); 
                  Calcule_et_Charge_consigne_DDS (ConsFreq);
                 }
                 OUT_LCD  
                 LCD_Erase_Ligne(2);  
                 FConsFreq= (float )ConsFreq;
                 txt=&Texte[0];
                 fltToa (FConsFreq,txt,1);
                 k=7-strlen(txt);
                 LCD_Pos(2,6);
                 while(k-->0)LCD_Put(' ');
                 LCD_PutRamString(txt);  LCD_Put(' ');LCD_Put('H');LCD_Put('z');        
                 Tempo(50000);
                 break;
            } 
            case 11 :  // mode DDS AD9835
             {
                 LCD_Erase_Ligne(1);
                 PrintOut_Eeprom_Msg(11);// mode AD9835
                 LCD_Erase_Ligne(2);
                 LCD_Pos(2,0);
                 txt=&Texte[0];
                 fltToa (Freq_AD9835,txt,2);
                 LCD_PutRamString(txt);
                 
                  jt=Time_Elapsed();
                 if (jt>0) 
                 {
                 M2=(long) ceil(Freq_AD9835);        
                 M2=Traite_Joystick_Freq (M2,1,20000000);      
                 LCD_Erase_Ligne(1);
                 PrintOut_Eeprom_Msg(12);// reglage Freq AD9835
                 LCD_Erase_Ligne(2);
                 Freq_AD9835=(float)M2;
                 txt=&Texte[0];
                 fltToa (Freq_AD9835,txt,1);
                 LCD_PutRamString(txt);
                 LCD_Put(' ');LCD_Put('H');LCD_Put('z');
                 AD9835_Charge_Freq(Freq_AD9835,0);
                 OUT_RS232
                  txt=&Texte[0];
                 fltToa (Freq_AD9835,txt,1);
                 k=PutStr_RS(txt);
                 CRLF();
                 OUT_LCD
                 Tempo(20000);
                }
                 break;  
             } 
            
          } //swith          
         
   OUT_LCD
   LCD_Erase_Ligne(1);   
   if  ( Pos_Menu_H<11)
   {    
         PrintOut_Eeprom_Msg(Pos_Menu_H); 
         Calcule_et_Charge_consigne_DDS (ConsFreq); 
      }   
      else  
          {
          PrintOut_Eeprom_Msg(11);// mode AD9835  
          LCD_Erase_Ligne(2);
          LCD_Pos(2,5);
          fltToa (Freq_AD9835,txt,1);
          LCD_PutRamString(txt);
          LCD_Put(' ');LCD_Put('H');LCD_Put('z'); 
    }   
  
     c=0;
     j=0;
     
   if(CMP1==1)
   {
     CMP1=0;
     PIR2bits.C1IF=0;
     }
   if (CMP2==1)
   {
    CMP2=0;
    PIR2bits.C2IF=0; 
    }
    PIE2bits.C1IE=1; 
    PIE2bits.C2IE=1;  
    PIR1bits.TMR1IF=0;     // raz flag IT RB0
   //  INTCONbits.INT0IE=1;  // reactive interrupt RB0
     PIE1bits.RC1IE =1;
     OUT_RS232
  }
     

//**************************
//           MAIN
//**************************
 void main()
 {
 Tempo(15000L);
 Init_Hardware() ;
 Led_Rouge=0;    //allume
 Led_Up =1;    
Led_Centre=1;
Led_Down=1;
 OneSecond=0;
 count=0;
 
  // init des pointeurs stockage reception car
 ptecr=buffer;
 ptlec= ptecr;
 txt=&Texte[0];
 // init accumulateur DDS PIC direct
 U1.ACCUMULATEUR=0;
 U2.ML=86;  // 1Hz
 Step=1;
 

  Flags.Fanion=0;           // <- init globale des flags a Zero
  Flags.Drapeaux.Fill=1;    // <- init individuelle des flags
  Flags.Drapeaux.Blc=1;
  Flags.Drapeaux.Elligible=0; // inutile mais pour la comprehension
  Flags.Drapeaux.Change=0;
  Flags.Drapeaux.FrameErr=0;
  Flags.Drapeaux.Over=0;

  CptFE=0;
  CptFO=0;
   ESC=0;

 OUT_RS232
 Init_UART1();	//19200 bauds
 Put_RS(CLS);
 Tempo(200000L);  // laisser un peu de temp pour l'effacement ecran Terminal VBray
 CRLF();
 
//**********  test : //Test_Joystick_Vertical_f_duree.txt *******


 strcpypgm2ram(&Texte[0],Menu_Str[1]);  // port com ouvert
 k=PutStr_RS(Texte); CRLF(); 
 strcpypgm2ram(&Texte[0],Menu_Str[13]);  // nom du fichier C
 k=PutStr_RS(Texte); CRLF();
 strcpypgm2ram(&Texte[0],Menu_Str[11]);  // Interface..
 k=PutStr_RS(Texte);
 strcpypgm2ram(&Texte[0],Menu_Str[12]); // gamme...
 k=PutStr_RS(Texte);

 PrintOut_Eeprom_Msg(0);      // 18F46k22...
 PrintOut_Eeprom_Msg(14);     // version MPLAB
 PrintOut_Eeprom_Msg(15);     // version du programme
 CRLF();
  
strcpypgm2ram(&Texte[0],Menu_Str[10]); // coeff DDS PIC
k=PutStr_RS(Texte);
FFacteur_PIC=Coeff_DDS;
fltToa (FFacteur_PIC,txt,6);
k=PutStr_RS(txt);
CRLF();

Led_Rouge=0;

// rajout LCD 2x16 
  OUT_LCD
  LCD_Init();                   // Lcd Init
  Tempo(250000L);

 
 OUT_RS232  
PrintOut_Eeprom_Msg(13);
Config_DAC();  // init DAC 5bits output and FVR at 4,096V

Init_ADC();

SaisieOk=0;

// init table sinus par defaut
 for (i=0;i<256;i++)
            {
             F1=(float)SINE_TABLE[i]/8.0;
             SIGNAL[i]=(char)(F1);
 }
 
 // init signal sinus a 1000Hz
 Pos_Menu_H=1;       // pointe sur libelle EEPROM SINUS 
 ChoixF=10;           // pointeur table freq definies sur le 10em element=1000Hz
 ConsFreq=1000;       // 1000Hz
 strcpypgm2ram(&Texte[0],Menu_Str[9]);
 k=PutStr_RS(Texte);
 U1.ACCUMULATEUR=0; // equivalent a  ACC_L=0;ACC_M=0,ACC_H=0;
 FConsFreq= (float )ConsFreq;
 FConsDDS=  FConsFreq / FFacteur_PIC;    // Calcul consigne DDS pour obtenir Freq Out
 MD.Cons_DDS= (long) ceil(FConsDDS); // rangement dans un long 32 bits
 ultoa(MD.Cons_DDS,&Texte[0]);       // verification en ascii
 k=PutStr_RS(Texte);                 // renvoi sur ecran
 Put_RS(TAB); //CRLF();
 Tempo(10000L);
 Taux=512;   // valeur taux rectangle a 50%
 
 OUT_LCD
 
 do
 {
  LCD_Erase_Ligne(1);
  LCD_Pos(1,0);   //1234567890123456
  LCD_PutRomString("1-ABCDEFGHIJKLMN");
  LCD_Erase_Ligne(2);
  LCD_PutRomString("2-OPQRSTUVWXYZ-*");
  Tempo(250000);
          
  LCD_Erase_Ligne(1);
  LCD_Pos(1,0);   //1234567890123456
  LCD_PutRomString("18F46K22 DDS C18");
  LCD_Erase_Ligne(2);
  LCD_Pos(2,0);
  PrintOut_Eeprom_Msg(0);
  Tempo(250000);


 LCD_Erase_Ligne(1);
 PrintOut_Eeprom_Msg(1);  // sinus
 LCD_Erase_Ligne(2);
 PrintOut_Eeprom_Msg(2);  
  Tempo(250000);
  
 LCD_Erase_Ligne(1);
 PrintOut_Eeprom_Msg(3);  
 LCD_Erase_Ligne(2);
 PrintOut_Eeprom_Msg(4);  
  Tempo(250000);
  
 LCD_Erase_Ligne(1);
 PrintOut_Eeprom_Msg(5);  
 LCD_Erase_Ligne(2);
 PrintOut_Eeprom_Msg(6);
 Tempo(250000);  
 
 
}
 while (1)  ;

}

